//========================================================================================
//
//	File:				FloatFrm.h
//	Release Version:	$ ODF 1 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FLOATFRM_H
#define FLOATFRM_H

// ----- Part Layer -----

#ifndef FWFRAME_H
#include "FWFrame.h"
#endif

// ----- OS Layer -----

#ifndef FWMAPING_H
#include "FWMaping.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

class FW_CMapping;

class CDrawPart;

//========================================================================================
// CFloatingWindowFrame
//========================================================================================

class CFloatingWindowFrame : public FW_CFrame
{
//----------------------------------------------------------------------------------------
// Initialization/destruction
//
public:		
	CFloatingWindowFrame(Environment* ev, ODFrame* odFrame, FW_CPresentation* presentation, CDrawPart* drawPart);
	virtual ~ CFloatingWindowFrame();

//----------------------------------------------------------------------------------------
// Inherited
//
public:	
	virtual void			FacetAdded(Environment* ev, ODFacet* facet, unsigned short facetCount);
	virtual void			FacetRemoved(Environment* ev, ODFacet* facet, unsigned short facetCount);
	
//----------------------------------------------------------------------------------------
// New API
//
protected:	
	void					EraseBackground(Environment* ev, FW_CGraphicContext& gc);
	void					HideShowFloating(Environment* ev);
	
//----------------------------------------------------------------------------------------
// Data Members
//
protected:	
	CDrawPart*				fDrawPart;
	ODFacet*				fFacet;
	FW_CMapping				fMapping;
};

#endif