//========================================================================================
//
//	File:				PatFrame.h
//	Release Version:	$ ODF 1 $
//
//	Author:				Henri Lamiraux
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PATFRAME_H
#define PATFRAME_H

#ifndef UTILS_H
#include "Utils.h"
#endif

// ----- OS Layer -----

#ifndef FLOATFRM_H
#include "FloatFrm.h"
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

class FW_CFacetContext;
class FW_CColor;
class FW_CMouseEvent;

//========================================================================================
// Constants
//========================================================================================

const FW_Fixed kPatternCellSize = FW_IntToFixed(24);

//========================================================================================
// Class CPatternFrame
//========================================================================================

class CPatternFrame : public CFloatingWindowFrame
{
//----------------------------------------------------------------------------------------
// Initialization/destruction
//
public:		

	FW_DECLARE_AUTO(CPatternFrame)
	
	CPatternFrame(Environment* ev, ODFrame* odFrame, FW_CPresentation* presentation, CDrawPart* drawPart);
	virtual ~ CPatternFrame();

//----------------------------------------------------------------------------------------
// Inherited API
//
public:	
	virtual void 			Draw(Environment* ev, ODFacet* odFacet, ODShape* invalidShape);
	virtual FW_Boolean		DoMouseDown(Environment* ev, const FW_CMouseEvent& theMouseEvent);

	virtual void			FacetAdded(Environment* ev, ODFacet* facet, unsigned short facetCount);
	
//----------------------------------------------------------------------------------------
// Data Members
//
private:
	CGrid					fGrid;
};

#endif
